local K, _, L = unpack(KkthnxUI)
local Module = K:GetModule("AurasTable")

local list = {
	["Enchant Aura"] = {
		{ AuraID = 341260, UnitID = "player", Flash = true },
		{ AuraID = 354808, UnitID = "player" },

		{ AuraID = 26297, UnitID = "player" },
		{ AuraID = 20572, UnitID = "player" },
		{ AuraID = 33697, UnitID = "player" },
		{ AuraID = 292463, UnitID = "player" },

		{ AuraID = 307195, UnitID = "player" },

		{ AuraID = 381476, UnitID = "player" },
		{ AuraID = 383941, UnitID = "player" },

		{ AuraID = 331937, UnitID = "player", Flash = true },
		{ AuraID = 354053, UnitID = "player", Flash = true, Text = L["Crit"] },
		{ AuraID = 354054, UnitID = "player", Flash = true, Text = L["Versa"] },
		{ AuraID = 323546, UnitID = "player" },
		{ AuraID = 326860, UnitID = "player" },
		{ AuraID = 310143, UnitID = "player", Combat = true },
		{ AuraID = 327104, UnitID = "player" },
		{ AuraID = 327710, UnitID = "player" },
		{ AuraID = 328933, UnitID = "player" },
		{ AuraID = 328281, UnitID = "player" },
		{ AuraID = 328282, UnitID = "player" },
		{ AuraID = 328620, UnitID = "player" },
		{ AuraID = 328622, UnitID = "player" },
		{ AuraID = 324867, UnitID = "player", Value = true },
		{ AuraID = 328204, UnitID = "player" },
		{ AuraID = 325748, UnitID = "player" },
		{ AuraID = 315443, UnitID = "player" },
		{ AuraID = 325299, UnitID = "player" },
		{ AuraID = 327164, UnitID = "player" },
		{ AuraID = 325216, UnitID = "player" },
		{ AuraID = 343672, UnitID = "player" },
		{ AuraID = 324220, UnitID = "player" },
		{ AuraID = 311648, UnitID = "player" },
		{ AuraID = 323558, UnitID = "player" },
		{ AuraID = 323559, UnitID = "player" },
		{ AuraID = 323560, UnitID = "player" },
		{ AuraID = 338142, UnitID = "player" },
		{ AuraID = 310454, UnitID = "player" },
		{ AuraID = 325013, UnitID = "player" },
		{ AuraID = 308495, UnitID = "player" },
		{ AuraID = 328908, UnitID = "player" },
		{ AuraID = 345499, UnitID = "player" },
		{ AuraID = 339461, UnitID = "player" },
		{ AuraID = 325381, UnitID = "player", Flash = true },
		{ AuraID = 351414, UnitID = "player", Flash = true },
		{ AuraID = 342774, UnitID = "player" },
		{ AuraID = 333218, UnitID = "player" },
		{ AuraID = 336885, UnitID = "player" },
		{ AuraID = 324156, UnitID = "player", Flash = true },
		{ AuraID = 333961, UnitID = "player" },
		{ AuraID = 333943, UnitID = "player" },
		{ AuraID = 339928, UnitID = "player", Flash = true },
		{ AuraID = 358404, UnitID = "player", Flash = true },
		{ AuraID = 352917, UnitID = "player" },
		{ AuraID = 356263, UnitID = "player" },
		{ AuraID = 352875, UnitID = "player", Flash = true },

		{ AuraID = 187616, UnitID = "player" },
		{ AuraID = 187617, UnitID = "player" },
		{ AuraID = 187618, UnitID = "player" },
		{ AuraID = 187619, UnitID = "player" },
		{ AuraID = 187620, UnitID = "player" },

		{ AuraID = 201405, UnitID = "player" },
		{ AuraID = 201408, UnitID = "player" },
		{ AuraID = 201410, UnitID = "player" },
		{ AuraID = 202052, UnitID = "player", Value = true },
	},
	["Raid Buff"] = {
		{ AuraID = 54861, UnitID = "player" },

		{ AuraID = 2825, UnitID = "player" },
		{ AuraID = 32182, UnitID = "player" },
		{ AuraID = 80353, UnitID = "player" },
		{ AuraID = 264667, UnitID = "player" },
		{ AuraID = 390386, UnitID = "player" },
		{ AuraID = 363534, UnitID = "player" },
		{ AuraID = 357170, UnitID = "player" },
		{ AuraID = 178207, UnitID = "player" },
		{ AuraID = 230935, UnitID = "player" },
		{ AuraID = 256740, UnitID = "player" },
		{ AuraID = 309658, UnitID = "player" },
		{ AuraID = 102364, UnitID = "player" },
		{ AuraID = 292686, UnitID = "player" },

		{ AuraID = 1022, UnitID = "player" },
		{ AuraID = 6940, UnitID = "player" },
		{ AuraID = 1044, UnitID = "player" },
		{ AuraID = 10060, UnitID = "player" },
		{ AuraID = 77761, UnitID = "player" },
		{ AuraID = 77764, UnitID = "player" },
		{ AuraID = 31821, UnitID = "player" },
		{ AuraID = 97463, UnitID = "player" },
		{ AuraID = 64843, UnitID = "player" },
		{ AuraID = 64901, UnitID = "player" },
		{ AuraID = 81782, UnitID = "player" },
		{ AuraID = 29166, UnitID = "player" },
		{ AuraID = 47788, UnitID = "player" },
		{ AuraID = 33206, UnitID = "player" },
		{ AuraID = 53563, UnitID = "player" },
		{ AuraID = 98007, UnitID = "player" },
		{ AuraID = 223658, UnitID = "player" },
		{ AuraID = 115310, UnitID = "player" },
		{ AuraID = 116849, UnitID = "player" },
		{ AuraID = 204018, UnitID = "player" },
		{ AuraID = 102342, UnitID = "player" },
		{ AuraID = 145629, UnitID = "player" },
		{ AuraID = 156910, UnitID = "player" },
		{ AuraID = 192082, UnitID = "player" },
		{ AuraID = 201633, UnitID = "player" },
		{ AuraID = 207498, UnitID = "player" },
		{ AuraID = 238698, UnitID = "player" },
		{ AuraID = 209426, UnitID = "player" },
		{ AuraID = 374227, UnitID = "player" },
		{ AuraID = 114018, UnitID = "player", Flash = true },
		{ AuraID = 115834, UnitID = "player", Flash = true },
	},
	["Raid Debuff"] = {

		{ AuraID = 311390, UnitID = "player" },
		{ AuraID = 306583, UnitID = "player" },
		{ AuraID = 313698, UnitID = "player", Flash = true },

		{ AuraID = 396364, UnitID = "player", Flash = true },
		{ AuraID = 396369, UnitID = "player", Flash = true },
		{ AuraID = 209858, UnitID = "player" },
		{ AuraID = 240559, UnitID = "player" },
		{ AuraID = 226512, UnitID = "player", Flash = true },
		{ AuraID = 240447, UnitID = "player", Flash = true },
		{ AuraID = 240443, UnitID = "player", Flash = true },
	},
	["Warning"] = {
		{ AuraID = 355596, UnitID = "target", Flash = true },

		{ AuraID = 304975, UnitID = "target", Value = true },
		{ AuraID = 319643, UnitID = "target", Value = true },

		{ AuraID = 226510, UnitID = "target" },
		{ AuraID = 343502, UnitID = "target" },

		{ AuraID = 498, UnitID = "target" },
		{ AuraID = 642, UnitID = "target" },
		{ AuraID = 871, UnitID = "target" },
		{ AuraID = 5277, UnitID = "target" },
		{ AuraID = 1044, UnitID = "target" },
		{ AuraID = 6940, UnitID = "target" },
		{ AuraID = 1022, UnitID = "target" },
		{ AuraID = 19574, UnitID = "target" },
		{ AuraID = 23920, UnitID = "target" },
		{ AuraID = 31884, UnitID = "target" },
		{ AuraID = 33206, UnitID = "target" },
		{ AuraID = 45438, UnitID = "target" },
		{ AuraID = 47585, UnitID = "target" },
		{ AuraID = 47788, UnitID = "target" },
		{ AuraID = 48792, UnitID = "target" },
		{ AuraID = 48707, UnitID = "target" },
		{ AuraID = 61336, UnitID = "target" },
		{ AuraID = 197690, UnitID = "target" },
		{ AuraID = 147833, UnitID = "target" },
		{ AuraID = 186265, UnitID = "target" },
		{ AuraID = 113862, UnitID = "target" },
		{ AuraID = 118038, UnitID = "target" },
		{ AuraID = 114050, UnitID = "target" },
		{ AuraID = 114051, UnitID = "target" },
		{ AuraID = 114052, UnitID = "target" },
		{ AuraID = 204018, UnitID = "target" },
		{ AuraID = 205191, UnitID = "target" },
		{ AuraID = 104773, UnitID = "target" },
		{ AuraID = 199754, UnitID = "target" },
		{ AuraID = 120954, UnitID = "target" },
		{ AuraID = 122278, UnitID = "target" },
		{ AuraID = 122783, UnitID = "target" },
		{ AuraID = 188499, UnitID = "target" },
		{ AuraID = 210152, UnitID = "target" },
		{ AuraID = 247938, UnitID = "target" },
		{ AuraID = 212800, UnitID = "target" },
		{ AuraID = 162264, UnitID = "target" },
		{ AuraID = 187827, UnitID = "target" },
		{ AuraID = 125174, UnitID = "target" },
		{ AuraID = 171607, UnitID = "target" },
		{ AuraID = 228323, UnitID = "target", Value = true },
	},
	["InternalCD"] = {
		{ IntID = 240447, Duration = 20 },
		{ IntID = 114018, Duration = 15, OnSuccess = true, UnitID = "all" },
	},
}

Module:AddNewAuraWatch("ALL", list)
