local _, C = unpack(KkthnxUI)

-- Thanks to ElvUI for providing great textures
local GetEmojiMedia = "Interface\\Addons\\KkthnxUI\\Media\\Chat\\Emojis\\"

local GetEmojiTexture = {
	Angry = GetEmojiMedia .. "Angry.tga",
	Blush = GetEmojiMedia .. "Blush.tga",
	BrokenHeart = GetEmojiMedia .. "BrokenHeart.tga",
	CallMe = GetEmojiMedia .. "CallMe.tga",
	Cry = GetEmojiMedia .. "Cry.tga",
	Facepalm = GetEmojiMedia .. "Facepalm.tga",
	Grin = GetEmojiMedia .. "Grin.tga",
	Heart = GetEmojiMedia .. "Heart.tga",
	HeartEyes = GetEmojiMedia .. "HeartEyes.tga",
	Joy = GetEmojiMedia .. "Joy.tga",
	Kappa = GetEmojiMedia .. "Kappa.tga",
	Meaw = GetEmojiMedia .. "Meaw.tga",
	MiddleFinger = GetEmojiMedia .. "MiddleFinger.tga",
	Murloc = GetEmojiMedia .. "Murloc.tga",
	OkHand = GetEmojiMedia .. "OkHand.tga",
	OpenMouth = GetEmojiMedia .. "OpenMouth.tga",
	Poop = GetEmojiMedia .. "Poop.tga",
	Rage = GetEmojiMedia .. "Rage.tga",
	SadKitty = GetEmojiMedia .. "SadKitty.tga",
	Scream = GetEmojiMedia .. "Scream.tga",
	ScreamCat = GetEmojiMedia .. "ScreamCat.tga",
	SemiColon = GetEmojiMedia .. "SemiColon.tga",
	SlightFrown = GetEmojiMedia .. "SlightFrown.tga",
	Smile = GetEmojiMedia .. "Smile.tga",
	Smirk = GetEmojiMedia .. "Smirk.tga",
	Sob = GetEmojiMedia .. "Sob.tga",
	StuckOutTongue = GetEmojiMedia .. "StuckOutTongue.tga",
	StuckOutTongueClosedEyes = GetEmojiMedia .. "StuckOutTongueClosedEyes.tga",
	Sunglasses = GetEmojiMedia .. "Sunglasses.tga",
	Thinking = GetEmojiMedia .. "Thinking.tga",
	ThumbsUp = GetEmojiMedia .. "ThumbsUp.tga",
	Wink = GetEmojiMedia .. "Wink.tga",
	ZZZ = GetEmojiMedia .. "ZZZ.tga",
}

-- EMOJI EXPRESSION MAPS
C.SetEmojiTexture = {
	[",,!,,"] = GetEmojiTexture.MiddleFinger,
	["8%)"] = GetEmojiTexture.Sunglasses,
	["8%-%)"] = GetEmojiTexture.Sunglasses,
	[":%$"] = GetEmojiTexture.Blush,
	[":%("] = GetEmojiTexture.SlightFrown,
	[":%)"] = GetEmojiTexture.Smile,
	[":%+1:"] = GetEmojiTexture.ThumbsUp,
	[":%-%("] = GetEmojiTexture.SlightFrown,
	[":%-%)"] = GetEmojiTexture.Smile,
	[":%-0"] = GetEmojiTexture.OpenMouth,
	[":%-@"] = GetEmojiTexture.Angry,
	[":%-D"] = GetEmojiTexture.Grin,
	[":%-O"] = GetEmojiTexture.OpenMouth,
	[":%-P"] = GetEmojiTexture.StuckOutTongue,
	[":%-S"] = GetEmojiTexture.Smirk,
	[":%-o"] = GetEmojiTexture.OpenMouth,
	[":%-p"] = GetEmojiTexture.StuckOutTongue,
	[":,%("] = GetEmojiTexture.Cry,
	[":,%-%("] = GetEmojiTexture.Cry,
	[":;:"] = GetEmojiTexture.SemiColon,
	[":@"] = GetEmojiTexture.Angry,
	[":D"] = GetEmojiTexture.Grin,
	[":F"] = GetEmojiTexture.MiddleFinger,
	[":O"] = GetEmojiTexture.OpenMouth,
	[":P"] = GetEmojiTexture.StuckOutTongue,
	[":S"] = GetEmojiTexture.Smirk,
	[':"%('] = GetEmojiTexture.Cry,
	[':"%)'] = GetEmojiTexture.Joy,
	[':"%-%('] = GetEmojiTexture.Cry,
	[":angry:"] = GetEmojiTexture.Angry,
	[":blush:"] = GetEmojiTexture.Blush,
	[":broken_heart:"] = GetEmojiTexture.BrokenHeart,
	[":call_me:"] = GetEmojiTexture.CallMe,
	[":cry:"] = GetEmojiTexture.Cry,
	[":facepalm:"] = GetEmojiTexture.Facepalm,
	[":grin:"] = GetEmojiTexture.Grin,
	[":heart:"] = GetEmojiTexture.Heart,
	[":heart_eyes:"] = GetEmojiTexture.HeartEyes,
	[":joy:"] = GetEmojiTexture.Joy,
	[":kappa:"] = GetEmojiTexture.Kappa,
	[":meaw:"] = GetEmojiTexture.Meaw,
	[":middle_finger:"] = GetEmojiTexture.MiddleFinger,
	[":murloc:"] = GetEmojiTexture.Murloc,
	[":o"] = GetEmojiTexture.OpenMouth,
	[":o3"] = GetEmojiTexture.ScreamCat,
	[":ok_hand:"] = GetEmojiTexture.OkHand,
	[":open_mouth:"] = GetEmojiTexture.OpenMouth,
	[":p"] = GetEmojiTexture.StuckOutTongue,
	[":poop:"] = GetEmojiTexture.Poop,
	[":rage:"] = GetEmojiTexture.Rage,
	[":sadkitty:"] = GetEmojiTexture.SadKitty,
	[":scream:"] = GetEmojiTexture.Scream,
	[":scream_cat:"] = GetEmojiTexture.ScreamCat,
	[":semi_colon:"] = GetEmojiTexture.SemiColon,
	[":slight_frown:"] = GetEmojiTexture.SlightFrown,
	[":smile:"] = GetEmojiTexture.Smile,
	[":smirk:"] = GetEmojiTexture.Smirk,
	[":sob:"] = GetEmojiTexture.Sob,
	[":stuck_out_tongue:"] = GetEmojiTexture.StuckOutTongue,
	[":stuck_out_tongue_closed_eyes:"] = GetEmojiTexture.StuckOutTongueClosedEyes,
	[":sunglasses:"] = GetEmojiTexture.Sunglasses,
	[":thinking:"] = GetEmojiTexture.Thinking,
	[":thumbs_up:"] = GetEmojiTexture.ThumbsUp,
	[":wink:"] = GetEmojiTexture.Wink,
	[":zzz:"] = GetEmojiTexture.ZZZ,
	[";%)"] = GetEmojiTexture.Wink,
	[";%-%)"] = GetEmojiTexture.Wink,
	[";%-D"] = GetEmojiTexture.Grin,
	[";%-P"] = GetEmojiTexture.StuckOutTongueClosedEyes,
	[";%-p"] = GetEmojiTexture.StuckOutTongueClosedEyes,
	[";D"] = GetEmojiTexture.Grin,
	[";P"] = GetEmojiTexture.StuckOutTongueClosedEyes,
	[';"%)'] = GetEmojiTexture.Joy,
	[";o;"] = GetEmojiTexture.Sob,
	[";p"] = GetEmojiTexture.StuckOutTongueClosedEyes,
	["</3"] = GetEmojiTexture.BrokenHeart,
	["<3"] = GetEmojiTexture.Heart,
	["<\\3"] = GetEmojiTexture.BrokenHeart,
	["=D"] = GetEmojiTexture.Grin,
	["=P"] = GetEmojiTexture.StuckOutTongue,
	["=p"] = GetEmojiTexture.StuckOutTongue,
	[">:%("] = GetEmojiTexture.Rage,
	["D:<"] = GetEmojiTexture.Rage,
	["XD"] = GetEmojiTexture.Grin,
	["XP"] = GetEmojiTexture.StuckOutTongueClosedEyes,
	["xD"] = GetEmojiTexture.Grin,
}
